#
# spec file for package lamertetris
#
# Copyright (c) 2020 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#

%define unmangled_version 2.230821-3
Name:           lamertetris
Version:		2.230821
Release:        3
Summary:    	My implementation of the cult game
License:        CC-PDDC
URL:            http://prymula.ct8.pl
Source0:	%{name}-%{unmangled_version}.tar.gz
%if 0%{?suse_version}==1530
BuildRequires:	libSDL2-devel, libSDL2_ttf-devel, pkgconfig, pkgconfig(sdl2), gcc-c++
Requires:       libSDL2-2_0-0, libSDL2_ttf-2_0-0
%else
BuildRequires:	SDL2-devel, SDL2_ttf-devel, pkgconfig, pkgconfig(sdl2), gcc-c++
Requires:       SDL2, SDL2_ttf
%endif
BuildArch:	x86_64

%description


%prep
%setup -n %{name}-%{unmangled_version} -n %{name}-%{unmangled_version}

%build
make

%install
mkdir -p %{buildroot}/usr
mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/share
mkdir -p %{buildroot}/usr/share/lamertetris
mkdir -p %{buildroot}/usr/share/lamertetris/img

#mkdir -p %{buildroot}/usr
#mkdir -p %{buildroot}/usr/share
mkdir -p %{buildroot}/usr/share/applications

#%make_install

install -m 0755 lamertetris %{buildroot}/usr/bin/lamertetris
install -m 0644 assets/lamertetris.png %{buildroot}/usr/share/lamertetris/img
install -m 0644 assets/lamertetris.bmp %{buildroot}/usr/share/lamertetris/img
install -m 0644 assets/wallpaper.bmp %{buildroot}/usr/share/lamertetris/img
install -m 0644 LamerTetris.desktop %{buildroot}/usr/share/applications
install -m 0644 assets/SpicyRice.ttf %{buildroot}/usr/share/lamertetris



%files
%defattr(0755,root,root)
/usr/bin/lamertetris
/usr/share/lamertetris/
/usr/share/lamertetris/img/
%defattr(0644,root,root)
/usr/share/lamertetris/img/lamertetris.png
/usr/share/lamertetris/img/lamertetris.bmp
/usr/share/lamertetris/img/wallpaper.bmp
/usr/share/applications/LamerTetris.desktop
/usr/share/lamertetris/SpicyRice.ttf

%changelog
